#include "bgr.h"
#include <string.h>
#include <stdlib.h>
#include <unistd.h>

int main(int argc, char **argv)
{
  BGR_sig *prevsig;
  BGR_sig *newsig;
  BGR_key *key;
  int mlen;
  unsigned char *message;

  if(argc != 2)
    {
      printf("Correct Usage: addsig signum.\n");
      exit(1);
    }

  int sig_num = atoi(argv[1]);
  if (sig_num < 1)
    {
      printf("Correct Usage: addsig signum.\nsignum should be at least 1.\n");
      exit(1);
    }

   
  if(sig_num == 1)
    prevsig = NULL;
  else
    prevsig = (BGR_sig *)sigFromFile(sig_num - 1);
  key = (BGR_key *)privateKeyFromFile(sig_num);
  singleMessageFromFile(sig_num,&message,&mlen);
  
  newsig = BGR_sign(message,mlen,key,prevsig);
  BGR_key_free(key);
  OPENSSL_free(message);
  if(prevsig != NULL)
    BGR_sig_free(prevsig);
  if(newsig == NULL)
    {
      BGR_sig_free(newsig);
      printf("error\n.");
    }
  else
    {
      sigToFile(newsig);
      BGR_sig_free(newsig);
    }
}
  
  
  
