#include <openssl/rsa.h>
#include <openssl/evp.h>
#include <openssl/hmac.h>
#include <openssl/engine.h>
#include <openssl/rand.h>
#include <openssl/pem.h>
#include <openssl/err.h>

#define LH 32
#define LX 256
#define LR 16 
#define LK 32


struct BGR_sig_st{
  unsigned char **r;
  unsigned int rlen;
  unsigned char *b;
  unsigned char *x;
  unsigned int xlen;
  unsigned char *h;
  unsigned int hlen;
  unsigned int i;
};

struct BGR_key_st{
  RSA *rsa;
  unsigned char *k;
  int klen;
};
typedef struct BGR_sig_st BGR_sig;
typedef struct BGR_key_st BGR_key;
BGR_sig *BGR_sig_new(int i);
BGR_key *BGR_gen(int num, unsigned long e);
void BGR_key_free(BGR_key *key);
void BGR_sig_free(BGR_sig *sig);
BGR_sig *BGR_sign(unsigned char *mi, int mlen, BGR_key *bgr, BGR_sig *prevsign);
int BGR_verify(RSA **public, char **messages, int *mlen, BGR_sig *sig);
