#include "bgr.h"
#include <string.h>
#include <stdlib.h>
#include <unistd.h>


int main(int argc, char **argv)
{
  int i;
  BGR_sig *sig;
  RSA **pubkeys;
  char **messages;
  int *mlens;
  int result;

  if(argc != 1)
    {
      printf("Correct Usage: versig.\n");
      exit(1);
    }

  sig = (BGR_sig *)sigFromFile(-1);
  messagesFromFile(sig->i,&messages,&mlens);
  pubkeys = (RSA **)publicKeysFromFile(sig->i);
  result = BGR_verify(pubkeys,messages,mlens,sig);
  for(i=1;i<=sig->i;i++)
    {
      OPENSSL_free(messages[i]);
      RSA_free(pubkeys[i]);
    }
  OPENSSL_free(pubkeys);
  BGR_sig_free(sig);
  OPENSSL_free(messages);
  OPENSSL_free(mlens);
  if(result == 1)
    printf("Signature Verified.\n");
  else
    printf("Invalid Signature.\n");
}
